;;;; posix-library.scm

(declare
  (uses posix)
  (disable-interrupts)
  (fixnum)
  (compress-literals 10) )

(library "chicken://posix" "scheme://chicken"

  (import-primitives
   open/nonblock
   perm/ixusr
   perm/irwxg
   file-permissions
   perm/irwxo
   perm/irwxu
   process
   set-signal-mask!
   prot/read
   errno/intr
   file-write
   file-modification-time
   regular-file?
   read-symbolic-link
   create-symbolic-link
   file-mkstemp
   seek/end
   open/write
   signal/io
   set-process-group-id!
   set-group-id!
   errno/busy
   open/append
   fifo?
   errno/acces
   errno/noexec
   set-buffering-mode!
   perm/isuid
   open-output-file*
   open-input-file*
   perm/iwoth
   memory-mapped-file?
   open/noctty
   errno/pipe
   initialize-groups
   get-groups
   errno/fault
   unsetenv
   set-file-position!
   find-files
   open/wronly
   errno/child
   file-truncate
   signal/vtalrm
   process-execute
   with-input-from-pipe
   file-test-lock
   signal/usr1
   seek/set
   signal/usr2
   signal/xfsz
   setenv
   errno/nomem
   file-stat
   signal/segv
   set-alarm!
   seconds->utc-time
   utc-time->seconds
   local-time->seconds
   local-timezone-abbreviation
   file-access-time
   port->fileno
   perm/isvtx
   file-lock
   set-root-directory!
   file-execute-access?
   file-write-access?
   file-read-access?
   errno/wouldblock
   errno/badf
   directory?
   set-groups!
   _exit
   call-with-output-pipe
   call-with-input-pipe
   close-output-pipe
   close-input-pipe
   open-output-pipe
   open-input-pipe
   signal/cont
   signal/prof
   perm/iroth
   seconds->local-time
   fileno/stdout
   prot/write
   time->string
   seconds->string
   map/shared
   errno/rofs
   signal/alrm
   open/rdonly
   set-user-id!
   file-position
   current-effective-user-id
   current-user-id
   errno/again
   glob
   errno/inval
   terminal-name
   perm/iwgrp
   fileno/stderr
   file-size
   file-open
   unmap-file-from-memory
   map-file-to-memory
   signal/abrt
   perm/ixoth
   prot/none
   fileno/stdin
   errno/spipe
   map/file
   change-file-owner
   file-owner
   open/fsync
   signal/pipe
   open/trunc
   signal/fpe
   signal/stop
   open/binary
   map/private
   file-close
   file-read
   errno/noent
   perm/irgrp
   file-select
   terminal-port?
   create-pipe
   perm/iwusr
   change-file-mode
   process-wait
   current-environment
   signal/term
   process-fork
   parent-process-id
   current-process-id
   signal/chld
   signal/trap
   open/text
   file-change-time
   signal/kill
   signal/winch
   errno/exist
   with-output-to-pipe
   duplicate-fileno
   open/excl
   map/anonymous
   errno/isdir
   signal/hup
   current-directory
   directory
   delete-directory
   change-directory
   create-directory
   get-host-name
   errno/nospc
   file-lock/blocking
   perm/ixgrp
   signal/ill
   errno/mfile
   pipe/buf
   perm/irusr
   errno/perm
   signal/int
   process-group-id
   current-effective-group-id
   current-group-id
   map/fixed
   symbolic-link?
   file-link
   open/read
   file-unlock
   create-session
   group-information
   user-information
   system-information
   signal/urg
   open/creat
   open/rdwr
   signal/tstp
   signal/quit
   process-signal
   process-run
   errno/notdir
   perm/isgid
   create-fifo
   seek/cur
   prot/exec
   errno/srch
   signal/xcpu
   set-signal-handler!
   sleep
   open/sync
   errno/io
   memory-mapped-file-pointer)

  (export
   open/nonblock
   perm/ixusr
   perm/irwxg
   file-permissions
   perm/irwxo
   perm/irwxu
   process
   set-signal-mask!
   prot/read
   errno/intr
   file-write
   file-modification-time
   regular-file?
   read-symbolic-link
   create-symbolic-link
   file-mkstemp
   seek/end
   open/write
   signal/io
   set-process-group-id!
   set-group-id!
   errno/busy
   open/append
   fifo?
   errno/acces
   errno/noexec
   set-buffering-mode!
   perm/isuid
   open-output-file*
   open-input-file*
   perm/iwoth
   memory-mapped-file?
   open/noctty
   errno/pipe
   initialize-groups
   get-groups
   errno/fault
   unsetenv
   set-file-position!
   find-files
   open/wronly
   errno/child
   file-truncate
   signal/vtalrm
   process-execute
   with-input-from-pipe
   file-test-lock
   signal/usr1
   seek/set
   signal/usr2
   signal/xfsz
   setenv
   errno/nomem
   file-stat
   signal/segv
   set-alarm!
   seconds->utc-time
   file-access-time
   port->fileno
   perm/isvtx
   file-lock
   set-root-directory!
   file-execute-access?
   file-write-access?
   file-read-access?
   errno/wouldblock
   errno/badf
   directory?
   set-groups!
   _exit
   call-with-output-pipe
   call-with-input-pipe
   close-output-pipe
   close-input-pipe
   open-output-pipe
   open-input-pipe
   signal/cont
   signal/prof
   perm/iroth
   seconds->local-time
   fileno/stdout
   prot/write
   time->string
   seconds->string
   map/shared
   errno/rofs
   signal/alrm
   open/rdonly
   set-user-id!
   file-position
   current-effective-user-id
   current-user-id
   errno/again
   glob
   errno/inval
   terminal-name
   perm/iwgrp
   fileno/stderr
   file-size
   file-open
   unmap-file-from-memory
   map-file-to-memory
   signal/abrt
   perm/ixoth
   prot/none
   fileno/stdin
   errno/spipe
   map/file
   change-file-owner
   file-owner
   open/fsync
   signal/pipe
   open/trunc
   signal/fpe
   signal/stop
   open/binary
   map/private
   file-close
   file-read
   errno/noent
   perm/irgrp
   file-select
   terminal-port?
   create-pipe
   perm/iwusr
   change-file-mode
   process-wait
   current-environment
   signal/term
   process-fork
   parent-process-id
   current-process-id
   signal/chld
   signal/trap
   open/text
   file-change-time
   signal/kill
   signal/winch
   errno/exist
   with-output-to-pipe
   duplicate-fileno
   open/excl
   map/anonymous
   errno/isdir
   signal/hup
   current-directory
   directory
   delete-directory
   change-directory
   create-directory
   get-host-name
   errno/nospc
   file-lock/blocking
   perm/ixgrp
   signal/ill
   errno/mfile
   pipe/buf
   perm/irusr
   errno/perm
   signal/int
   process-group-id
   current-effective-group-id
   current-group-id
   map/fixed
   symbolic-link?
   file-link
   open/read
   file-unlock
   create-session
   group-information
   user-information
   system-information
   signal/urg
   open/creat
   open/rdwr
   signal/tstp
   signal/quit
   process-signal
   process-run
   errno/notdir
   perm/isgid
   create-fifo
   seek/cur
   prot/exec
   errno/srch
   signal/xcpu
   set-signal-handler!
   sleep
   open/sync
   errno/io
   memory-mapped-file-pointer))
