;;;; tinyclos-library.scm

(declare
  (uses tinyclos)
  (disable-interrupts)
  (fixnum)
  (compress-literals 10) )

(library "chicken://tinyclos-internals" "scheme://chicken"

  (import-primitives
   initialize-slots
   compute-slots
   <tcp-listener>
   <char-set>
   <boolean>
   <number>
   <swig-pointer>
   <tagged-pointer>
   <pointer>
   slot-ref
   <exact>
   <primitive-class>
   <procedure-class>
   <entity-class>
   <end-of-file>
   <null>
   <inexact>
   <port>
   <symbol>
   compute-cpl
   <output-port>
   <input-port>
   class-of
   <c++-object>
   <object>
   <char>
   <pair>
   <structure>
   class-name
   add-method
   make-method
   make-class
   <generic>
   <void>
   class-cpl
   <locative>
   initialize
   compute-apply-generic
   make-generic
   <primitive>
   method-specializers
   class-direct-slots
   <queue>
   instance?
   allocate-instance
   instance-of?
   <promise>
   <mmap>
   <array>
   class-direct-supers
   <lock>
   <hash-table>
   make
   <environment>
   <class>
   method-procedure
   <top>
   <condition>
   <procedure>
   describe-object
   print-object
   slot-set!
   <integer>
   compute-getter-and-setter
   <method>
   <string>
   compute-apply-methods
   compute-methods
   generic-methods
   compute-method-more-specific?
   subclass?
   <time>
   class-slots
   <f64vector>
   <f32vector>
   <s32vector>
   <u32vector>
   <s16vector>
   <u16vector>
   <s8vector>
   <u8vector>
   <byte-vector>
   <vector>)

  (export
   initialize-slots
   compute-slots
   <tcp-listener>
   <char-set>
   <boolean>
   <number>
   <swig-pointer>
   <tagged-pointer>
   <pointer>
   slot-ref
   <exact>
   <primitive-class>
   <procedure-class>
   <entity-class>
   <end-of-file>
   <null>
   <inexact>
   <port>
   <symbol>
   compute-cpl
   <output-port>
   <input-port>
   class-of
   <c++-object>
   <object>
   <char>
   <pair>
   <structure>
   class-name
   add-method
   make-method
   make-class
   <generic>
   <void>
   class-cpl
   <locative>
   initialize
   compute-apply-generic
   make-generic
   <primitive>
   method-specializers
   class-direct-slots
   <queue>
   instance?
   allocate-instance
   instance-of?
   <promise>
   <mmap>
   <array>
   class-direct-supers
   <lock>
   <hash-table>
   make
   <environment>
   <class>
   method-procedure
   <top>
   <condition>
   <procedure>
   describe-object
   print-object
   slot-set!
   <integer>
   compute-getter-and-setter
   <method>
   <string>
   compute-apply-methods
   compute-methods
   generic-methods
   compute-method-more-specific?
   subclass?
   <time>
   class-slots
   <f64vector>
   <f32vector>
   <s32vector>
   <u32vector>
   <s16vector>
   <u16vector>
   <s8vector>
   <u8vector>
   <byte-vector>
   <vector>))

(eval
 '(library "chicken://tinyclos" "scheme://chicken"

      (export
       initialize-slots
       compute-slots
       <tcp-listener>
       <char-set>
       <boolean>
       <number>
       <swig-pointer>
       <tagged-pointer>
       <pointer>
       slot-ref
       <exact>
       <primitive-class>
       <procedure-class>
       <entity-class>
       <end-of-file>
       <null>
       <inexact>
       <port>
       <symbol>
       compute-cpl
       <output-port>
       <input-port>
       class-of
       <c++-object>
       <object>
       <char>
       <pair>
       <structure>
       class-name
       add-method
       make-method
       make-class
       <generic>
       <void>
       class-cpl
       <locative>
       initialize
       compute-apply-generic
       make-generic
       <primitive>
       method-specializers
       class-direct-slots
       <queue>
       instance?
       allocate-instance
       instance-of?
       <promise>
       <mmap>
       <array>
       class-direct-supers
       <lock>
       <hash-table>
       make
       <environment>
       <class>
       method-procedure
       <top>
       <condition>
       <procedure>
       describe-object
       print-object
       slot-set!
       <integer>
       compute-getter-and-setter
       <method>
       <string>
       compute-apply-methods
       compute-methods
       generic-methods
       compute-method-more-specific?
       subclass?
       <time>
       class-slots
       <f64vector>
       <f32vector>
       <s32vector>
       <u32vector>
       <s16vector>
       <u16vector>
       <s8vector>
       <u8vector>
       <byte-vector>
       <vector>
       define-generic
       define-class
       define-method)

    (import "chicken://tinyclos-internals")

    (define-syntax (define-class name supers slots . meta)
      #`(set! 
	 ,name
	 (make ,(if (pair? meta) (car meta) #'<class>)
	   'name ',name
	   'direct-supers (list ,@(if (null? supers) #'(<object>) supers))
	   'direct-slots (list ,@(map (lambda (s) #`',s) slots)) ) ) )

    (define-syntax (define-generic name . class)
      #`(define ,name (make ,(if (pair? class) (car class) #'<generic>) 'name ',name)) )
  
    (define-syntax (define-method head . body)
      (let gather ([args (cdr head)]
		   [specs '()]
		   [vars '()] )
	(if (not (pair? args))
	    (let ([name (car head)])
	      #`(add-method
		 ,name
		 (make-method
		  (list ,@(reverse specs))
		  (lambda (call-next-method ,@(reverse vars) . ,args) ,@body) ) ) )
	    (let ([arg (car args)])
	      (gather (cdr args)
		      (cons (if (pair? arg) (cadr arg) #'<top>) specs)
		      (cons (if (pair? arg) (car arg) arg) vars) ) ) ) ) ) ) )
